<%@ Control Language="vb" debug="true" ClassName="ricoResponse" %>
<%@ Register TagPrefix="Rico" TagName="sqlParse" Src="sqlParse.ascx" %>
<%@ Import Namespace="System.Data" %>
<script runat="server">

Public dbConnection as object
Public dbDialect as String
Protected dbVersion as String
Protected dbClassName as String
Public RequestId as string     
Public offset as integer = 0
Public numrows as integer = 1999
Public AllRowsMax as integer = 1999  ' max # of rows to send if numrows=-1
Public gettotal as Boolean = true
Public distinctCol as integer = -1
Public editCol as integer = -1
Public Headings(-1) as string
Public HiddenCols(-1) as string
Public filters as ArrayList
Public orderByRef = false     ' use column numbers in order by clause? (true/false)
Public Wildcard as String="%"
Public oParse as object       ' parsed sql select statement to execute
Public sqlText as String      ' sql query to execute (either oParse or sqlText must be set prior to rendering)
Public ErrorMsg as String     ' may contain the text of an error message that occurred outside this control prior to rendering
Public HeaderRows as new ArrayList()  ' data that will be inserted before the query results
Public FooterRows as new ArrayList()  ' data that will be appended after the query results
Public fmt as string
Public SendHdg as Boolean = false
Public RenderFlag as Boolean = true
Protected command as object

' DEBUGGING CONTROL
Public sendDebugMsgs as Boolean = false   ' send details of sql parsing/execution in ajax response? (true/false)
Public LogSqlOnError as Boolean = false   ' include sql statement in results if an error occurs (true/false)
Protected DebugMsgs as new ArrayList()


Protected Sub Page_Init(Sender As object, e As EventArgs)
  RequestId = trim(Request.QueryString("id"))
  fmt = trim(Request.QueryString("_fmt"))
  dim sRequestOffset as string = trim(Request.QueryString("offset"))
  dim sRequestSize as string   = trim(Request.QueryString("page_size"))
  dim sRequestTotal as string  = lcase(Request.QueryString("get_total"))
  dim sDistinct as string      = trim(Request.QueryString("distinct"))
  dim sEdit as string          = trim(Request.QueryString("edit"))
  dim sHidden as string        = trim(Request.QueryString("hidden"))
  if not IsNumeric(sRequestOffset) then sRequestOffset="0"

  if sRequestOffset<>"" then offset=CLng(sRequestOffset)
  if sRequestSize<>"" then numrows=CLng(sRequestSize)
  if sDistinct<>"" then distinctCol=CLng(sDistinct)
  if sEdit<>"" then editCol=CLng(sEdit)
  if sHidden<>"" then HiddenCols=split(sHidden,",")
  gettotal=(sRequestTotal="true")
End Sub


Protected Overrides Sub Render(writer as HTMLTextWriter)
  Me.RunQuery(writer)
End Sub


'Protected Overrides Sub Render(writer as HTMLTextWriter)
Public Sub RunQuery(writer as HTMLTextWriter)
  Dim SqlRows as integer=0
  dim closetags as string, RowsStart as string, RowsEnd as string

  if not RenderFlag then exit sub
  Response.clear
  if fmt<>"xl" then
    Response.CacheControl = "no-cache"
    Response.AddHeader("Pragma", "no-cache")
    Response.Expires = -1
  end if
  select case fmt
    case "html":
      Response.ContentType="text/html"
      writer.WriteLine("<html><head></head><body>")
      closetags="</body></html>"
      RowsStart=vbLf & "<table border='1'>"
      RowsEnd=vbLf & "</table>"
      gettotal=false
      sendDebugMsgs=false
      SendHdg=true
    case "xl":
      Response.ContentType="application/vnd.ms-excel"
      writer.WriteLine("<html><head></head><body>")
      closetags="</body></html>"
      RowsStart=vbLf & "<table>"
      RowsEnd=vbLf & "</table>"
      gettotal=false
      sendDebugMsgs=false
      SendHdg=true
    case "json":
      Response.ContentType="application/json"
      writer.Write("{" & vbLf & """id"":""" & RequestId & """")
      RowsStart="," & vbLf & """update_ui"":true," & vbLf & """offset"":" & offset & "," & vbLf & """rows"":["
      RowsEnd=vbLf & "]"
      closetags="}"
    case else:
      ' default to xml
      fmt="xml"
      Response.ContentType="text/xml"
      writer.WriteLine("<?xml version='1.0' encoding='iso-8859-1'?>")
      writer.WriteLine("<ajax-response><response type='object' id='" & RequestId & "'>")
      closetags="</response></ajax-response>"
      RowsStart=vbLf & "<rows update_ui='true' offset='" & offset & "'>"
      RowsEnd=vbLf & "</rows>"
  end select

  if RequestId="" then
    ErrorMsg="No ID provided!"
  elseif IsNothing(dbConnection) and (not IsNothing(oParse) or not IsNothing(sqlText)) then
    ErrorMsg="No database connection"
  end if

  if not IsNothing(ErrorMsg) then
    ErrorResponse(writer, ErrorMsg)
  else

    writer.WriteLine(RowsStart)
    try
      writer.WriteLine(join(HeaderRows.ToArray(),vbLf))
      if not IsNothing(dbConnection) then
        SqlRows=RenderQueryRows(writer)
      end if
      writer.WriteLine(join(FooterRows.ToArray(),vbLf))
      writer.WriteLine(RowsEnd)
      if SqlRows >= 0 and (fmt="xml" or fmt="json") then
        AppendResponse(writer, "rowcount", CStr(SqlRows+HeaderRows.count+FooterRows.count))
      end if
      if sendDebugMsgs then
        AppendArrayResponse(writer, "debug", DebugMsgs.ToArray())
      end if
    Catch ex As Exception
      writer.WriteLine(RowsEnd)
      dim msg as string = ex.Message
      if LogSqlOnError AndAlso not IsNothing(sqlText) then msg &= " - " & sqlText
      ErrorResponse(writer, msg)
    end try
  end if
  writer.WriteLine(closetags)
End Sub


Public Sub ErrorResponse(writer as HTMLTextWriter, msg as string)
  AppendResponse(writer,"error",msg)
end sub


Public Sub AppendResponse(writer as HTMLTextWriter, tag as string, content as string)
  select case fmt
    case "html", "xl":
      writer.write(vbLf & "<p>" & tag & "<br>" & server.htmlencode(content) & "</p>")
    case "json":
      writer.write("," & vbLf & """" & tag & """:""" & escapeJSON(content) & """")
    case "xml":
      writer.write(vbLf & "<" & tag & ">" & server.htmlencode(content) & "</" & tag & ">")
  end select
end sub


Public Sub AppendArrayResponse(writer as HTMLTextWriter, tag as string, arContent as object())
  dim item as string, i as integer
  select case fmt
    case "html", "xl":
      writer.write(vbLf & "<p>" & tag)
      for each item in arContent
        writer.write("<br>" & server.htmlencode(item))
      next
      writer.write("</p>")
    case "json":
      writer.write("," & vbLf & """" & tag & """:[")
      for i=0 to arContent.Length-1
        arContent(i)="""" & escapeJSON(arContent(i)) & """"
      next
      writer.write(join(arContent,",") & "]")
    case "xml":
      for each item in arContent
        writer.write(vbLf & "<" & tag & ">" & server.htmlencode(item) & "</" & tag & ">")
      next
  end select
end sub


' returns the total number of rows produced by the query (or -1 if unknown)
Protected Function RenderQueryRows(writer as HTMLTextWriter) As Integer
  dim rowcnt as integer, fldNum as integer, dbDate as DateTime, strFieldItem as String
  dim firstCol as Integer=0, limitQuery as Boolean=false, eof as Boolean=false, n as String
  dim rdr as object
  dim totcnt as Integer=0

  RenderQueryRows=-1
  dbVersion=dbConnection.ServerVersion
  dbClassName=TypeName(dbConnection)
  command = dbConnection.CreateCommand()
  if not IsNothing(oParse) then
    if distinctCol >= 0 then
      ApplyQStringParms()
      sqlText=oParse.UnparseDistinctColumn(distinctCol)
    elseif editCol >= 0 then
      sqlText=oParse.SelectList(editCol).LookupQuery
      oParse=new sqlParse()
      oParse.ParseSelect(sqlText)
      ApplyQStringParms()
      sqlText=oParse.UnparseSelect()
    elseif numrows < 0 then
      ApplyQStringParms()
      sqlText=oParse.UnparseSelectSkip(HiddenCols)
    else
      ApplyQStringParms()
      select case dbDialect
        case "TSQL":
          if left(dbVersion,2) >= "09" then
            sqlText=oParse.UnparseWithRowNumber(offset,numrows+1,true,HiddenCols)
            firstCol=1
            limitQuery=true
          else
            sqlText=oParse.UnparseSelectSkip(HiddenCols)
          end if
        case "Oracle": 
          sqlText=oParse.UnparseWithRowNumber(offset,numrows+1,false,HiddenCols)
          firstCol=1
          limitQuery=true
        case "MySQL":
          sqlText=oParse.UnparseSelectSkip(HiddenCols) & " LIMIT " & offset & "," & CStr(numrows+1)
          limitQuery=true
        case else:
          sqlText=oParse.UnparseSelectSkip(HiddenCols)
      end select  
    end if
  end if
  if IsNothing(sqlText) then Exit Function
  DebugMsgs.add(sqlText)
  DebugMsgs.add(dbClassName)
  DebugMsgs.add("DB version=" & dbVersion)
  command.CommandText = sqlText
  rdr = command.ExecuteReader()

  if limitQuery then
    totcnt=offset
  else
    while (totcnt < offset) and (not eof)
      if rdr.Read() then
        totcnt += 1
      else
        eof=true
      end if
    end while
  end if

  rowcnt=0
  if numrows < 0 then numrows=AllRowsMax
  if fmt="json" then
    if SendHdg then
      writer.Write(vbLf & "[")
      for fldNum=firstCol to rdr.FieldCount -1
        if IsNothing(oParse) then
          n=Nothing
        else
          n=oParse.Headings(fldNum-firstCol)
        end if
        if IsNothing(n) then n=rdr.GetName(fldNum)
        writer.Write("""" & escapeJSON(n) & """")
      next
      writer.Write("]")
    end if
    while (rowcnt < numrows) and (not eof)
      if rdr.Read() then
        if rowcnt > 0 or SendHdg then writer.Write(",")
        writer.Write(vbLf & "[")
        for fldNum = firstCol to rdr.FieldCount -1
          strFieldItem = ""
          if not rdr.IsDBNull(fldNum) then
            select case rdr.GetFieldType(fldNum).Name
              case "DateTime":
                dbDate=rdr.GetDateTime(fldNum)
                strFieldItem = replace(dbDate.ToString("s"),"T"," ")  ' convert to ISO-8601 format
              case else:
                strFieldItem = escapeJSON(rdr.GetValue(fldNum))
            end select
          end if
          if fldNum > firstCol then writer.Write(",")
          writer.Write("""" & strFieldItem & """")
        next
        writer.Write("]")
        rowcnt += 1
      else
        eof=true
      end if
    end while
  else
    if SendHdg then
      writer.Write(vbLf & "<tr>")
      for fldNum=firstCol to rdr.FieldCount -1
        if IsNothing(oParse) then
          n=Nothing
        else
          n=oParse.Headings(fldNum-firstCol)
        end if
        if IsNothing(n) then n=rdr.GetName(fldNum)
        writer.Write("<td>" & server.HTMLEncode(n) & "</td>")
      next
      writer.Write("</tr>")
    end if
    while (rowcnt < numrows) and (not eof)
      if rdr.Read() then
        rowcnt += 1
        writer.Write("<tr>")
        for fldNum = firstCol to rdr.FieldCount -1
          strFieldItem = ""
          if not rdr.IsDBNull(fldNum) then
            select case rdr.GetFieldType(fldNum).Name
              case "DateTime":
                dbDate=rdr.GetDateTime(fldNum)
                strFieldItem = replace(dbDate.ToString("s"),"T"," ")  ' convert to ISO-8601 format
              case else:
                strFieldItem = server.HTMLEncode(rdr.GetValue(fldNum))
            end select
          end if
          writer.Write("<td>" & strFieldItem & "</td>")
        next
        writer.Write("</tr>")
      else
        eof=true
      end if
    end while
  end if
  totcnt += rowcnt

  if not eof and gettotal then
    if limitQuery then
      rdr.Close()
      dim countSql,cnt
      countSql="SELECT " & oParse.UnparseColumnList() & " FROM " & oParse.FromClause
      if not IsNothing(oParse.WhereClause) then countSql &= " WHERE " & oParse.WhereClause
      if oParse.GroupBy.count > 0 then countSql &= " GROUP BY " & join(oParse.GroupBy.ToArray(),",")
      if not IsNothing(oParse.HavingClause) then countSql &= " HAVING " & oParse.HavingClause
      countSql="SELECT COUNT(*) FROM (" & countSql & ")"
      if dbDialect<>"Oracle" then countSql &= " AS rico_Main"
      DebugMsgs.add(countSql)
      command.CommandText = countSql
      totcnt = command.ExecuteScalar()
      eof=true
    else
      while rdr.Read()
        totcnt += 1
      end while
      eof=true
    end if
  end if
  if eof then RenderQueryRows=totcnt
  rdr.Close()
End Function


' returns the parameter symbol to insert into the sql string
Private Function PushParam(ByVal newvalue) as String
  dim ParamName as String
  newvalue=cstr(newvalue)
  if newvalue="" then newvalue=" "  ' empty string gets converted to TEXT data type instead of VARCHAR
  select case dbClassName
    case "SqlConnection":
      ParamName="@P" & CStr(command.parameters.count)
      PushParam=ParamName
    case else:
      ParamName=""
      PushParam="?"
  end select
  command.parameters.add(ParamName,newvalue)
  DebugMsgs.add("Param " & ParamName & " value=" & newvalue)
End Function


' assumes oParse is already initialized
Private sub ApplyQStringParms()
  dim i, a, flen
  dim j as Integer, fop as String, ParamSymbol as String
  dim newfilter as string, qs as string, value as string

  for each qs in Request.QueryString
    select case left(qs,1)
      
      ' user-invoked condition
      case "w","h":
        i=mid(qs,2)
        if IsNumeric(i) then
          i=CInt(i)
          if i<0 or i>=filters.Count then exit for
          value=Request.QueryString(qs)
          newfilter=filters(i)
          j=InStr(1,newfilter," in (?)",1)
          if j>0 then
            a=split(value,",")
            for i=0 to ubound(a)
              ParamSymbol=PushParam(a(i))
              a(i)=ParamSymbol
            next
            newfilter=left(newfilter,j+4) & join(a,",") & mid(newfilter,j+6)
          elseif InStr(newfilter,"?")>0 then
            ParamSymbol=PushParam(value)
            if ParamSymbol<>"?" then newfilter=replace(newfilter,"?",ParamSymbol)
          end if
          if left(qs,1)="h" then
            oParse.AddHavingCondition(newfilter)
          else
            oParse.AddWhereCondition(newfilter)
          end if
        end if
      
      ' sort
      case "s":
        i=mid(qs,2)
        if not IsNumeric(i) then exit for
        i=CInt(i)
        if i<0 or i>=oParse.SelectList.count then exit for
        value=ucase(left(Request.QueryString(qs),4))
        if value<>"ASC" and value<>"DESC" then value="ASC"
        if orderByRef then
          oParse.AddSort(CStr(i+1) & " " & value)
        else
          oParse.AddSort(oParse.SelectList(i).sql & " " & value)
        end if
      
      ' user-supplied filter
      case "f":
        a=split(qs,"[")
        if ubound(a)=2 then
          if a(2)="op]" then
            i=left(a(1),len(a(1))-1)
            if not IsNumeric(i) then exit for
            if len(i)>3 then exit for
            i=CInt(i)
            if i<0 or i>oParse.SelectList.count then exit for
            fop=Request.QueryString(qs)
            newfilter=oParse.SelectList(i).sql
            select case fop
              case "EQ":
                newfilter = "(" & AddCoalesce(newfilter) & " IN " & GetMultiParmFilter(qs) & ")"
              case "LE":
                newfilter &= "<=" & PushParam(Request.QueryString(replace(qs,"[op]","[0]")))
              case "GE":
                newfilter &= ">=" & PushParam(Request.QueryString(replace(qs,"[op]","[0]")))
              case "NULL": newfilter &= " is null"
              case "NOTNULL": newfilter &= " is not null"
              case "LIKE":
                newfilter &= " LIKE " & PushParam(replace(Request.QueryString(replace(qs,"[op]","[0]")),"*",Wildcard))
              case "NE"
                newfilter = "(" & AddCoalesce(newfilter) & " NOT IN " & GetMultiParmFilter(qs) & ")"
            end select
            dim sql=oParse.SelectList(i).sql
            if (InStr(sql,"min(")>0 or _
               InStr(sql,"max(")>0 or _
               InStr(sql,"sum(")>0 or _
               InStr(sql,"count(")>0) and _
               InStr(sql,"(select ")<1 then
              oParse.AddHavingCondition(newfilter)
            else
              oParse.AddWhereCondition(newfilter)
            end if
          end if
        end if
    end select
  next
end sub


Private function AddCoalesce(newfilter as String) as String
  if dbDialect="Access" then
    newfilter="iif(IsNull(" & newfilter & "),''," & newfilter & ")"
  else
    newfilter="coalesce(" & newfilter & ",'')"
  end if
  AddCoalesce=newfilter
end function


Private function GetMultiParmFilter(qs as String) as String
  dim flenStr as String = Request.QueryString(replace(qs,"[op]","[len]"))
  if not IsNumeric(flenStr) then exit function
  dim flen as Integer = CInt(flenStr)
  dim j as Integer, param as String, filter as String = ""
  for j=0 to flen-1
    if j>0 then filter &= ","
    param=Request.QueryString(replace(qs,"[op]","[" & j & "]"))
    filter &= PushParam(param)
  next
  GetMultiParmFilter = "(" & filter & ")"
end function


Public function XmlStringCell(value as object) as String
  dim result
  if IsDBNull(value) then result="" else result=server.HTMLEncode(value)
  XmlStringCell="<td>" & result & "</td>"
end function


' for the root node, parentID should "" (empty string)
' containerORleaf: L/zero (leaf), C/non-zero (container)
' selectable:      0->not selectable, 1->selectable
Public function WriteTreeRow(parentID,ID,description,containerORleaf,selectable)
  HeaderRows.Add(TreeRow(parentID,ID,description,containerORleaf,selectable))
end function

Public function TreeRow(parentID,ID,description,containerORleaf,selectable)
  TreeRow="<tr>" & XmlStringCell(parentID) & XmlStringCell(ID) & XmlStringCell(description) & XmlStringCell(containerORleaf) & XmlStringCell(selectable) & "</tr>"
end function

'******************************************************************************************
'' @SDESCRIPTION:   takes a given string and makes it JSON valid (http://json.org/)
'' @AUTHOR: Michael Rebec
'' @DESCRIPTION:    all characters which needs to be escaped are beeing replaced by their
''          unicode representation according to the
''          RFC4627#2.5 - http://www.ietf.org/rfc/rfc4627.txt?number=4627
'' @PARAM:      val [string]: value which should be escaped
'' @RETURN:   [string] JSON valid string
'******************************************************************************************
public function escapeJSON(val)
    const cDoubleQuote = &h22
    const cRevSolidus = &h5C
    const cSolidus = &h2F
    dim i as integer, currentDigit as string

    for i = 1 to (len(val))
        currentDigit = mid(val, i, 1)
        if asc(currentDigit)> &h00 and asc(currentDigit) <&h1F then
            currentDigit = escapeJSONSquence(currentDigit)
        elseif asc(currentDigit)>= &hC280 and asc(currentDigit) <= &hC2BF then
            currentDigit = "\u00" + right(padLeft(hex(asc(currentDigit) - &hC200), 2, 0), 2)
        elseif asc(currentDigit)>= &hC380 and asc(currentDigit) <= &hC3BF then
            currentDigit = "\u00" + right(padLeft(hex(asc(currentDigit) - &hC2C0), 2, 0), 2)
        else
            select case asc(currentDigit)
                case cDoubleQuote: currentDigit = escapeJSONSquence(currentDigit)
                case cRevSolidus: currentDigit = escapeJSONSquence(currentDigit)
                case cSolidus: currentDigit = escapeJSONSquence(currentDigit)
            end select
        end if
        escapeJSON = escapeJSON & currentDigit
    next
end function
 
function escapeJSONSquence(digit)
    escapeJSONSquence = "\u00" + right(padLeft(hex(asc(digit)), 2, 0), 2)
end function 
 
function padLeft(value, totalLength, paddingChar)
    padLeft = right(clone(paddingChar, totalLength) & value, totalLength)
end function
 
public function clone(byVal str, n)
    dim i as integer
    for i = 1 to n : clone = clone & str : next
end function

</script>
